GNU Radio C++ API Reference: gr::fec::generic_decoder Class Reference

| GNU Radio C++ API Reference 3.10.12.0 The Free & Open Software Radio Ecosystem |

Loading...
Searching...
No Matches
gr::fec::generic_decoder Class Referenceabstract
GNU Radio C++ Signal Processing Blocks » Error Coding and Decoding

Parent class for FECAPI objects. More...

`#include <gnuradio/fec/generic_decoder.h>`

## Public Types
typedef std::shared_ptr< generic_decoder > | sptr

## Public Member Functions
virtual void | generic_work (const void *inbuffer, void *outbuffer)=0
int | unique_id ()
std::string | alias ()
| generic_decoder (void)
| generic_decoder (std::string name)
virtual | ~generic_decoder ()
virtual double | rate ()=0
virtual int | get_input_size ()=0
virtual int | get_output_size ()=0
virtual int | get_history ()
virtual float | get_shift ()
virtual int | get_input_item_size ()
virtual int | get_output_item_size ()
virtual const char * | get_input_conversion ()
virtual const char * | get_output_conversion ()
virtual bool | set_frame_size (unsigned int frame_size)=0
virtual float | get_iterations ()

## Public Attributes
int | my_id
std::string | d_name

## Static Public Attributes
static int | base_unique_id

## Protected Attributes
gr::logger_ptr | d_logger

## Friends
class | decoder

## Detailed Description

Parent class for FECAPI objects.

Parent of a decoder variable class for FECAPI that will fit into the gr::fec::decoder block to handle FEC decoding. This class provides the basic information required to fit into the FECAPI structure. It provides information about input and output data types, potential data conversions, and a few other parameters useful to establish the decoder's behavior.

We create objects from FECAPI-derived classes to go into the actual GNU Radio decoder block. Each object contains its own state and so there should be a one-to-one mapping of an FECAPI object and a GR decoder block. Sharing these objects is not guaranteed to be thread-safe.

This is a pure virtual class and must be derived from by a child class.

See also
  gr::fec::code::cc_decoder
  gr::fec::code::ccsds_decoder

## Member Typedef Documentation

## ◆ sptr

typedef std::shared_ptr<generic_decoder> gr::fec::generic_decoder::sptr

## Constructor & Destructor Documentation

## ◆ generic_decoder() [1/2]

gr::fec::generic_decoder::generic_decoder | ( | void |  | ) |
| inline

## ◆ generic_decoder() [2/2]

gr::fec::generic_decoder::generic_decoder | ( | std::string | name | ) |

## ◆ ~generic_decoder()

virtual gr::fec::generic_decoder::~generic_decoder | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ alias()

std::string gr::fec::generic_decoder::alias | ( |  | ) |
| inline

References d_name, and unique_id().

## ◆ generic_work()

virtual void gr::fec::generic_decoder::generic_work | ( | const void * | inbuffer,
|  | void * | outbuffer )
| pure virtual

Implemented in gr::fec::code::polar_decoder_sc, gr::fec::code::polar_decoder_sc_list, and gr::fec::code::polar_decoder_sc_systematic.

## ◆ get_history()

virtual int gr::fec::generic_decoder::get_history | ( |  | ) |
| virtual

Sets up history for the decoder when the decoder is required to look ahead in the data stream in order to finish its processing.

The child class MAY implement this function. If not reimplemented, it returns 0.

## ◆ get_input_conversion()

virtual const char * gr::fec::generic_decoder::get_input_conversion | ( |  | ) |
| virtual

Set up a conversion type required to setup the data properly for this decoder. The decoder itself will not implement the conversion and expects an external wrapper (e.g., fec.extended_decoder) to read this value and "do the right thing" to format the data.

The default behavior is 'none', which means no conversion is required. Whatever the get_input_item_size() value returns, the input is expected to conform directly to this.

This may also return 'uchar', which indicates that the wrapper should convert the standard float samples to unsigned characters, either hard sliced or 8-bit soft symbols. See gr::fec::code::cc_decoder as an example decoder that uses this conversion format.

If 'packed_bits', the block expects the inputs to be packed hard bits. Each input item is a unsigned char where each of the 8-bits is a hard bit value.

The child class SHOULD implement this function. If not reimplemented, it returns "none".

## ◆ get_input_item_size()

virtual int gr::fec::generic_decoder::get_input_item_size | ( |  | ) |
| virtual

Sets the size of an input item, as in the size of a char or float item.

The child class SHOULD implement this function. If not reimplemented, it returns sizeof(float) as the decoders typically expect floating point input types.

Reimplemented in gr::fec::ldpc_decoder.

## ◆ get_input_size()

virtual int gr::fec::generic_decoder::get_input_size | ( |  | ) |
| pure virtual

Returns the input size in items that the decoder object uses to decode a full frame. Often, this number is the number of bits per frame if the input format is unpacked. If the block expects packed bytes, then this value should be the number of bytes (number of bits / 8) per input frame.

The child class MUST implement this function.

Implemented in gr::fec::code::polar_decoder_common, and gr::fec::ldpc_decoder.

## ◆ get_iterations()

virtual float gr::fec::generic_decoder::get_iterations | ( |  | ) |
| inlinevirtual

Get repetitions to decode.

The child class should implement this function and return the number of iterations required to decode.

Reimplemented in gr::fec::ldpc_decoder.

## ◆ get_output_conversion()

virtual const char * gr::fec::generic_decoder::get_output_conversion | ( |  | ) |
| virtual

Set up a conversion type required to understand the output style of this decoder. Generally, follow-on processing expects unpacked bits, so we specify the conversion type here to indicate what the wrapper (e.g., fec.extended_decoder) should do to convert the output samples from the decoder into unpacked bits.

The default behavior is 'none', which means no conversion is required. This should mean that the output data is produced from this decoder as unpacked bit.

If 'unpack', the block produces packed bytes that should be unpacked by the wrapper. See gr::fec::code::ccsds_decoder as an example of a decoder that produces packed bytes.

The child class SHOULD implement this function. If not reimplemented, it returns "none".

## ◆ get_output_item_size()

virtual int gr::fec::generic_decoder::get_output_item_size | ( |  | ) |
| virtual

Sets the size of an output item, as in the size of a char or float item.

The child class SHOULD implement this function. If not reimplemented, it returns sizeof(char) as the decoders typically expect to produce bits or bytes.

Reimplemented in gr::fec::ldpc_decoder.

## ◆ get_output_size()

virtual int gr::fec::generic_decoder::get_output_size | ( |  | ) |
| pure virtual

Returns the output size in items that the decoder object produces after decoding a full frame. Often, this number is the number of bits in the outputted frame if the input format is unpacked. If the block produces packed bytes, then this value should be the number of bytes (number of bits / 8) per frame produced. This value is generally something like get_input_size()/R for a 1/R rate code.

The child class MUST implement this function.

Implemented in gr::fec::code::polar_decoder_common, and gr::fec::ldpc_decoder.

## ◆ get_shift()

virtual float gr::fec::generic_decoder::get_shift | ( |  | ) |
| virtual

Some decoders require the input items to float around a particular soft value. We can set that floating value by setting this value to return some non-zero number.

The fec.extended_decoder block will use this to create an add_const_ff block before the decoder block to adjust all input samples appropriately.

The child class MAY implement this function. If not reimplemented, it returns 0.

## ◆ rate()

virtual double gr::fec::generic_decoder::rate | ( |  | ) |
| pure virtual

Returns the rate of the code. For every r input bits, there is 1 output bit, so the rate is 1/r. Used for setting things like the encoder block's relative rate.

This function MUST be reimplemented by the child class.

Implemented in gr::fec::code::cc_decoder, gr::fec::code::dummy_decoder, gr::fec::code::ldpc_bit_flip_decoder, gr::fec::code::polar_decoder_common, gr::fec::code::repetition_decoder, gr::fec::ldpc_decoder, and gr::fec::tpc_decoder.

## ◆ set_frame_size()

virtual bool gr::fec::generic_decoder::set_frame_size | ( | unsigned int | frame_size | ) |
| pure virtual

Updates the size of a decoded frame.

The child class MUST implement this function and interpret how the `frame_size` information affects the block's behavior. It should also provide bounds checks.

Implemented in gr::fec::code::cc_decoder, gr::fec::code::dummy_decoder, gr::fec::code::ldpc_bit_flip_decoder, gr::fec::code::polar_decoder_common, gr::fec::code::repetition_decoder, gr::fec::ldpc_decoder, and gr::fec::tpc_decoder.

## ◆ unique_id()

int gr::fec::generic_decoder::unique_id | ( |  | ) |

Referenced by alias().

## Friends And Related Symbol Documentation

## ◆ decoder

friend class decoder
| friend

References decoder.

Referenced by decoder.

## Member Data Documentation

## ◆ base_unique_id

int gr::fec::generic_decoder::base_unique_id
| static

## ◆ d_logger

gr::logger_ptr gr::fec::generic_decoder::d_logger
| protected

## ◆ d_name

std::string gr::fec::generic_decoder::d_name

Referenced by alias().

## ◆ my_id

int gr::fec::generic_decoder::my_id

The documentation for this class was generated from the following file:

- generic_decoder.h